Revert unintentional change of daemon log file names
[ganeti-local] / Makefile.am
index 3f02202..644bddf 100644 (file)
@@ -21,12 +21,16 @@ ACLOCAL_AMFLAGS = -I autotools
 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
-CHECK_MAN = $(top_srcdir)/autotools/check-man
+CHECK_HEADER = $(top_srcdir)/autotools/check-header
+CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
+CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
 CHECK_VERSION = $(top_srcdir)/autotools/check-version
 CHECK_NEWS = $(top_srcdir)/autotools/check-news
+CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
 DOCPP = $(top_srcdir)/autotools/docpp
 REPLACE_VARS_SED = autotools/replace_vars.sed
 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
+BUILD_RPC = $(top_srcdir)/autotools/build-rpc
 
 # Note: these are automake-specific variables, and must be named after
 # the directory + 'dir' suffix
@@ -52,8 +56,16 @@ myexeclibdir = $(pkglibdir)
 HTOOLS_DIRS = \
        htools \
        htools/Ganeti \
+       htools/Ganeti/Confd \
        htools/Ganeti/HTools \
-       htools/Ganeti/HTools/Program
+       htools/Ganeti/HTools/Program \
+       htools/Ganeti/Query \
+       htest \
+       htest/Test \
+       htest/Test/Ganeti \
+       htest/Test/Ganeti/Confd \
+       htest/Test/Ganeti/HTools \
+       htest/Test/Ganeti/Query
 
 DIRS = \
        autotools \
@@ -81,6 +93,11 @@ DIRS = \
        qa \
        test \
        test/data \
+       test/data/ovfdata \
+       test/data/ovfdata/other \
+       htest/data \
+       htest/data/rapi \
+       htest/shelltests \
        tools
 
 BUILDTIME_DIR_AUTOCREATE = \
@@ -88,8 +105,11 @@ BUILDTIME_DIR_AUTOCREATE = \
        $(APIDOC_DIR) \
        $(APIDOC_PY_DIR) \
        $(APIDOC_HS_DIR) \
-       $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
+       $(APIDOC_HS_DIR)/Ganeti \
+       $(APIDOC_HS_DIR)/Ganeti/Confd \
+       $(APIDOC_HS_DIR)/Ganeti/HTools \
        $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
+       $(APIDOC_HS_DIR)/Ganeti/Query \
        $(COVERAGE_DIR) \
        $(COVERAGE_PY_DIR) \
        $(COVERAGE_HS_DIR) \
@@ -104,8 +124,6 @@ DIRCHECK_EXCLUDE = \
        ganeti-[0-9]*.[0-9]*.[0-9]* \
        doc/html/_*
 
-all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
-
 # some helper vars
 COVERAGE_DIR = doc/coverage
 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
@@ -129,47 +147,71 @@ CLEANFILES = \
        $(addsuffix /*.py[co],$(DIRS)) \
        $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
        $(addsuffix /*.o,$(HTOOLS_DIRS)) \
-       $(all_dirfiles) \
        $(PYTHON_BOOTSTRAP) \
        epydoc.conf \
-       autotools/replace_vars.sed \
+       $(REPLACE_VARS_SED) \
        daemons/daemon-util \
        daemons/ganeti-cleaner \
        devel/upload \
+       $(BUILT_EXAMPLES) \
        doc/examples/bash_completion \
-       doc/examples/ganeti.initd \
-       doc/examples/ganeti-kvm-poweroff.initd \
-       doc/examples/ganeti.cron \
-       doc/examples/gnt-config-backup \
-       doc/examples/hooks/ipsec \
+       doc/examples/bash_completion-debug \
+       lib/_generated_rpc.py \
        $(man_MANS) \
        $(manhtml) \
        tools/kvm-ifup \
+       stamp-directories \
        stamp-srclinks \
        $(nodist_pkgpython_PYTHON) \
        $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
-       .hpc/*.mix htools/*.tix \
+       $(HS_BUILT_TEST_HELPERS) \
+       .hpc/*.mix htools/*.tix htest/*.tix \
        doc/hs-lint.html
 
-# BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
-# it'll cause the target to rebuild every time.
-BUILT_SOURCES = \
-       ganeti \
-       stamp-srclinks \
-       $(all_dirfiles) \
-       $(PYTHON_BOOTSTRAP) \
-       $(BUILT_PYTHON_SOURCES)
+GENERATED_FILES = \
+       $(built_base_sources) \
+       $(BUILT_PYTHON_SOURCES) \
+       $(PYTHON_BOOTSTRAP)
 
-BUILT_PYTHON_SOURCES = \
+HTOOLS_GENERATED_FILES =
+if WANT_HTOOLS
+HTOOLS_GENERATED_FILES += $(HS_PROGS)
+if HS_CONFD
+HTOOLS_GENERATED_FILES += htools/hconfd
+endif
+endif
+
+built_base_sources = \
+       stamp-directories \
+       stamp-srclinks
+
+built_python_base_sources = \
        lib/_autoconf.py \
        lib/_vcsversion.py
 
+BUILT_PYTHON_SOURCES = \
+       $(built_python_base_sources) \
+       lib/_generated_rpc.py
+
+# Generating the RPC wrappers depends on many things, so make sure
+# it's built at the end of the built sources
+lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
+
+# these are all built from the underlying %.in sources
+BUILT_EXAMPLES = \
+       doc/examples/ganeti-kvm-poweroff.initd \
+       doc/examples/ganeti.cron \
+       doc/examples/ganeti.initd \
+       doc/examples/gnt-config-backup \
+       doc/examples/hooks/ipsec
+
 nodist_pkgpython_PYTHON = \
        $(BUILT_PYTHON_SOURCES)
 
 noinst_PYTHON = \
        lib/build/__init__.py \
-       lib/build/sphinx_ext.py
+       lib/build/sphinx_ext.py \
+       lib/build/shell_example_lexer.py
 
 pkgpython_PYTHON = \
        lib/__init__.py \
@@ -192,16 +234,21 @@ pkgpython_PYTHON = \
        lib/mcpu.py \
        lib/netutils.py \
        lib/objects.py \
+       lib/objectutils.py \
        lib/opcodes.py \
+       lib/ovf.py \
+       lib/pathutils.py \
        lib/qlang.py \
        lib/query.py \
        lib/rpc.py \
+       lib/rpc_defs.py \
        lib/runtime.py \
        lib/serializer.py \
        lib/ssconf.py \
        lib/ssh.py \
        lib/storage.py \
        lib/uidpool.py \
+       lib/vcluster.py \
        lib/workerpool.py
 
 client_PYTHON = \
@@ -230,7 +277,8 @@ rapi_PYTHON = \
        lib/rapi/client.py \
        lib/rapi/client_utils.py \
        lib/rapi/connector.py \
-       lib/rapi/rlib2.py
+       lib/rapi/rlib2.py \
+       lib/rapi/testutils.py
 
 http_PYTHON = \
        lib/http/__init__.py \
@@ -246,6 +294,7 @@ confd_PYTHON = \
 
 masterd_PYTHON = \
        lib/masterd/__init__.py \
+       lib/masterd/iallocator.py \
        lib/masterd/instance.py
 
 impexpd_PYTHON = \
@@ -303,8 +352,14 @@ docrst = \
        doc/design-network.rst \
        doc/design-chained-jobs.rst \
        doc/design-ovf-support.rst \
+       doc/design-autorepair.rst \
+       doc/design-resource-model.rst \
        doc/cluster-merge.rst \
        doc/design-shared-storage.rst \
+       doc/design-node-state-cache.rst \
+       doc/design-virtual-clusters.rst \
+       doc/design-bulk-create.rst \
+       doc/design-query-splitting.rst \
        doc/devnotes.rst \
        doc/glossary.rst \
        doc/hooks.rst \
@@ -315,29 +370,40 @@ docrst = \
        doc/locking.rst \
        doc/move-instance.rst \
        doc/news.rst \
+       doc/ovfconverter.rst \
        doc/rapi.rst \
        doc/security.rst \
        doc/upgrade.rst \
        doc/walkthrough.rst
 
 HS_PROGS = htools/htools
-HS_BIN_ROLES = hbal hscan hspace
+HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
+HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
 
-HS_ALL_PROGS = $(HS_PROGS) htools/test
+HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
-# we don't add -Werror by default
-HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
-# extra flags that can be overriden on the command line
+HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
+
+HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
+# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
 HEXTRA =
+# internal extra flags (used for htest/test mainly)
+HEXTRA_INT =
 # exclude options for coverage reports
-HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
+HPCEXCL = --exclude Main \
        --exclude Ganeti.Constants \
-       --exclude Ganeti.HTools.Version
+       --exclude Ganeti.THH \
+       --exclude Ganeti.HTools.QC \
+       --exclude Ganeti.Version \
+       --exclude Test.Ganeti.TestCommon \
+       --exclude Test.Ganeti.TestHTools \
+       --exclude Test.Ganeti.TestHelper \
+       --exclude Test.Ganeti.TestImports \
+       $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
 
 HS_LIB_SRCS = \
        htools/Ganeti/HTools/CLI.hs \
        htools/Ganeti/HTools/Cluster.hs \
-       htools/Ganeti/HTools/Compat.hs \
        htools/Ganeti/HTools/Container.hs \
        htools/Ganeti/HTools/ExtLoader.hs \
        htools/Ganeti/HTools/Group.hs \
@@ -347,24 +413,86 @@ HS_LIB_SRCS = \
        htools/Ganeti/HTools/Luxi.hs \
        htools/Ganeti/HTools/Node.hs \
        htools/Ganeti/HTools/PeerMap.hs \
-       htools/Ganeti/HTools/QC.hs \
        htools/Ganeti/HTools/Rapi.hs \
        htools/Ganeti/HTools/Simu.hs \
        htools/Ganeti/HTools/Text.hs \
        htools/Ganeti/HTools/Types.hs \
        htools/Ganeti/HTools/Utils.hs \
+       htools/Ganeti/HTools/Program.hs \
        htools/Ganeti/HTools/Program/Hail.hs \
        htools/Ganeti/HTools/Program/Hbal.hs \
+       htools/Ganeti/HTools/Program/Hcheck.hs \
+       htools/Ganeti/HTools/Program/Hinfo.hs \
        htools/Ganeti/HTools/Program/Hscan.hs \
        htools/Ganeti/HTools/Program/Hspace.hs \
+       htools/Ganeti/BasicTypes.hs \
+       htools/Ganeti/Common.hs \
+       htools/Ganeti/Compat.hs \
+       htools/Ganeti/Confd.hs \
+       htools/Ganeti/Confd/Server.hs \
+       htools/Ganeti/Confd/Utils.hs \
+       htools/Ganeti/Config.hs \
+       htools/Ganeti/Daemon.hs \
+       htools/Ganeti/Hash.hs \
        htools/Ganeti/Jobs.hs \
+       htools/Ganeti/JSON.hs \
+       htools/Ganeti/Logging.hs \
        htools/Ganeti/Luxi.hs \
-       htools/Ganeti/OpCodes.hs
-
-HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
+       htools/Ganeti/Objects.hs \
+       htools/Ganeti/OpCodes.hs \
+       htools/Ganeti/Path.hs \
+       htools/Ganeti/Query/Common.hs \
+       htools/Ganeti/Query/Filter.hs \
+       htools/Ganeti/Query/Group.hs \
+       htools/Ganeti/Query/Language.hs \
+       htools/Ganeti/Query/Node.hs \
+       htools/Ganeti/Query/Query.hs \
+       htools/Ganeti/Query/Server.hs \
+       htools/Ganeti/Query/Types.hs \
+       htools/Ganeti/Rpc.hs \
+       htools/Ganeti/Runtime.hs \
+       htools/Ganeti/Ssconf.hs \
+       htools/Ganeti/THH.hs
+
+HS_TEST_SRCS = \
+       htest/Test/Ganeti/BasicTypes.hs \
+       htest/Test/Ganeti/Common.hs \
+       htest/Test/Ganeti/Daemon.hs \
+       htest/Test/Ganeti/Confd/Utils.hs \
+       htest/Test/Ganeti/HTools/CLI.hs \
+       htest/Test/Ganeti/HTools/Cluster.hs \
+       htest/Test/Ganeti/HTools/Container.hs \
+       htest/Test/Ganeti/HTools/Instance.hs \
+       htest/Test/Ganeti/HTools/Loader.hs \
+       htest/Test/Ganeti/HTools/Node.hs \
+       htest/Test/Ganeti/HTools/PeerMap.hs \
+       htest/Test/Ganeti/HTools/Simu.hs \
+       htest/Test/Ganeti/HTools/Text.hs \
+       htest/Test/Ganeti/HTools/Types.hs \
+       htest/Test/Ganeti/HTools/Utils.hs \
+       htest/Test/Ganeti/JSON.hs \
+       htest/Test/Ganeti/Jobs.hs \
+       htest/Test/Ganeti/Luxi.hs \
+       htest/Test/Ganeti/Objects.hs \
+       htest/Test/Ganeti/OpCodes.hs \
+       htest/Test/Ganeti/Query/Filter.hs \
+       htest/Test/Ganeti/Query/Language.hs \
+       htest/Test/Ganeti/Query/Query.hs \
+       htest/Test/Ganeti/Rpc.hs \
+       htest/Test/Ganeti/Ssconf.hs \
+       htest/Test/Ganeti/TestCommon.hs \
+       htest/Test/Ganeti/TestHTools.hs \
+       htest/Test/Ganeti/TestHelper.hs
+
+HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
+
+HS_BUILT_SRCS = \
+       htest/Test/Ganeti/TestImports.hs \
+       htools/Ganeti/Constants.hs \
+       htools/Ganeti/Version.hs
 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
 
-$(RUN_IN_TEMPDIR): | $(all_dirfiles)
+$(RUN_IN_TEMPDIR): | stamp-directories
 
 # Note: we use here an order-only prerequisite, as the contents of
 # _autoconf.py are not actually influencing the html build output: it
@@ -372,7 +500,8 @@ $(RUN_IN_TEMPDIR): | $(all_dirfiles)
 # successfully, but we certainly don't want the docs to be rebuilt if
 # it changes
 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
-       $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
+       $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
+       lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
        | $(BUILT_PYTHON_SOURCES)
        @test -n "$(SPHINX)" || \
            { echo 'sphinx-build' not found during configure; exit 1; }
@@ -411,12 +540,9 @@ docpng = $(patsubst %.dot,%.png,$(docdot))
 noinst_DATA = \
        devel/upload \
        doc/html \
+       $(BUILT_EXAMPLES) \
        doc/examples/bash_completion \
-       doc/examples/ganeti.cron \
-       doc/examples/ganeti.initd \
-       doc/examples/ganeti-kvm-poweroff.initd \
-       doc/examples/gnt-config-backup \
-       doc/examples/hooks/ipsec \
+       doc/examples/bash_completion-debug \
        $(manhtml)
 
 gnt_scripts = \
@@ -430,25 +556,22 @@ gnt_scripts = \
        scripts/gnt-os
 
 PYTHON_BOOTSTRAP_SBIN = \
-       daemons/ganeti-confd \
        daemons/ganeti-masterd \
        daemons/ganeti-noded \
        daemons/ganeti-watcher \
        daemons/ganeti-rapi \
-       scripts/gnt-backup \
-       scripts/gnt-cluster \
-       scripts/gnt-debug \
-       scripts/gnt-group \
-       scripts/gnt-instance \
-       scripts/gnt-job \
-       scripts/gnt-node \
-       scripts/gnt-os
+       $(gnt_scripts)
+
+if PY_CONFD
+PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
+endif
 
 PYTHON_BOOTSTRAP = \
        $(PYTHON_BOOTSTRAP_SBIN) \
        tools/ensure-dirs
 
 qa_scripts = \
+       qa/__init__.py \
        qa/ganeti-qa.py \
        qa/qa_cluster.py \
        qa/qa_config.py \
@@ -457,6 +580,7 @@ qa_scripts = \
        qa/qa_error.py \
        qa/qa_group.py \
        qa/qa_instance.py \
+       qa/qa_job.py \
        qa/qa_node.py \
        qa/qa_os.py \
        qa/qa_rapi.py \
@@ -475,27 +599,50 @@ install-exec-hook:
                $(LN_S) -f htools \
                           $(DESTDIR)$(bindir)/$$role ; \
        done
+if HS_CONFD
+       mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
+endif
 endif
 
-$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
+$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
        @if [ -z "$(HTOOLS)" ]; then \
          echo "Error: htools compilation disabled at configure time" 1>&2 ;\
          exit 1; \
        fi
-       @BINARY=$(@:htools/%=%); \
-       if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
+       @if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
          echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
          exit 1; \
        fi
-       BINARY=$(@:htools/%=%); $(GHC) --make \
-         $(HFLAGS) $(HEXTRA) \
+       @rm -f $(notdir $@).tix
+       $(GHC) --make \
+         $(HFLAGS) \
          $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
-         -osuf $$BINARY.o -hisuf $$BINARY.hi $@
+         -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
+         $(HEXTRA) $(HEXTRA_INT) $@
+       @touch "$@"
 
-# for the htools/test binary, we need to enable profiling/coverage
-htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
-       -fno-warn-monomorphism-restriction -fno-warn-orphans \
-       -fno-warn-missing-methods -fno-warn-unused-imports
+# for the htest/test binary, we need to enable profiling/coverage
+htest/test: HEXTRA_INT=-fhpc -ihtest
+
+# we compile the hpc-htools binary with the program coverage
+htest/hpc-htools: HEXTRA_INT=-fhpc
+
+# test dependency
+htest/offline-tests.sh: htest/hpc-htools
+
+# rules for building profiling-enabled versions of the haskell
+# programs: hs-prof does the full two-step build, whereas
+# hs-prof-quick does only the final rebuild (hs-prof must have been
+# run before)
+.PHONY: hs-prof hs-prof-quick
+hs-prof:
+       $(MAKE) $(AM_MAKEFLAGS) clean
+       $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
+       rm -f $(HS_ALL_PROGS)
+       $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
+
+hs-prof-quick:
+       $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
 
 dist_sbin_SCRIPTS = \
        tools/ganeti-listrunner
@@ -504,21 +651,29 @@ nodist_sbin_SCRIPTS = \
        $(PYTHON_BOOTSTRAP_SBIN) \
        daemons/ganeti-cleaner
 
+if HS_CONFD
+nodist_sbin_SCRIPTS += htools/hconfd
+endif
+
 python_scripts = \
        tools/burnin \
        tools/cfgshell \
        tools/cfgupgrade \
        tools/cfgupgrade12 \
        tools/cluster-merge \
+       tools/confd-client \
+       tools/fmtjson \
        tools/lvmstrap \
        tools/move-instance \
+       tools/ovfconverter \
        tools/setup-ssh \
        tools/sanitize-config
 
 dist_tools_SCRIPTS = \
        $(python_scripts) \
        tools/kvm-console-wrapper \
-       tools/xm-console-wrapper
+       tools/xm-console-wrapper \
+       tools/master-ip-setup
 
 pkglib_python_scripts = \
        daemons/import-export \
@@ -541,8 +696,12 @@ EXTRA_DIST = \
        epydoc.conf.in \
        pylintrc \
        autotools/build-bash-completion \
+       autotools/build-rpc \
+       autotools/check-header \
        autotools/check-python-code \
-       autotools/check-man \
+       autotools/check-imports \
+       autotools/check-man-dashes \
+       autotools/check-man-warnings \
        autotools/check-news \
        autotools/check-tar \
        autotools/check-version \
@@ -550,6 +709,7 @@ EXTRA_DIST = \
        autotools/docpp \
        autotools/gen-coverage \
        autotools/testrunner \
+       autotools/wrong-hardcoded-paths \
        $(RUN_IN_TEMPDIR) \
        daemons/daemon-util.in \
        daemons/ganeti-cleaner.in \
@@ -561,17 +721,14 @@ EXTRA_DIST = \
        $(docrst) \
        doc/conf.py \
        doc/html \
-       doc/examples/ganeti.initd.in \
-       doc/examples/ganeti-kvm-poweroff.initd.in \
-       doc/examples/ganeti.cron.in \
-       doc/examples/gnt-config-backup.in \
+       $(BUILT_EXAMPLES:%=%.in) \
        doc/examples/ganeti.default \
        doc/examples/ganeti.default-debug \
        doc/examples/hooks/ethers \
-       doc/examples/hooks/ipsec.in \
        doc/examples/gnt-debug/README \
        doc/examples/gnt-debug/delay0.json \
        doc/examples/gnt-debug/delay50.json \
+       test/lockperf.py \
        test/testutils.py \
        test/mocks.py \
        $(dist_TESTS) \
@@ -581,8 +738,11 @@ EXTRA_DIST = \
        $(maninput) \
        qa/qa-sample.json \
        $(qa_scripts) \
-       $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
-       $(HS_PROG_SRCS)
+       $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
+       $(HS_PROG_SRCS) \
+       htools/lint-hints.hs \
+       htest/cli-tests-defs.sh \
+       htest/offline-test.sh
 
 man_MANS = \
        man/ganeti.7 \
@@ -604,6 +764,8 @@ man_MANS = \
        man/gnt-os.8 \
        man/hail.1 \
        man/hbal.1 \
+       man/hcheck.1 \
+       man/hinfo.1 \
        man/hscan.1 \
        man/hspace.1 \
        man/htools.1
@@ -640,9 +802,67 @@ TEST_FILES = \
        test/data/kvm_0.12.5_help.txt \
        test/data/kvm_0.9.1_help.txt \
        test/data/sys_drbd_usermode_helper.txt \
-       test/import-export_unittest-helper
+       test/data/ovfdata/compr_disk.vmdk.gz \
+       test/data/ovfdata/config.ini \
+       test/data/ovfdata/corrupted_resources.ovf \
+       test/data/ovfdata/empty.ini \
+       test/data/ovfdata/empty.ovf \
+       test/data/ovfdata/ganeti.mf \
+       test/data/ovfdata/ganeti.ovf \
+       test/data/ovfdata/gzip_disk.ovf \
+       test/data/ovfdata/new_disk.vmdk \
+       test/data/ovfdata/no_disk.ini \
+       test/data/ovfdata/no_disk_in_ref.ovf \
+       test/data/ovfdata/no_os.ini \
+       test/data/ovfdata/no_ovf.ova \
+       test/data/ovfdata/ova.ova \
+       test/data/ovfdata/second_disk.vmdk \
+       test/data/ovfdata/rawdisk.raw \
+       test/data/ovfdata/unsafe_path.ini \
+       test/data/ovfdata/virtualbox.ovf \
+       test/data/ovfdata/wrong_extension.ovd \
+       test/data/ovfdata/wrong_config.ini \
+       test/data/ovfdata/wrong_manifest.mf \
+       test/data/ovfdata/wrong_manifest.ovf \
+       test/data/ovfdata/wrong_ova.ova \
+       test/data/ovfdata/wrong_xml.ovf \
+       test/data/ovfdata/other/rawdisk.raw \
+       test/data/vgreduce-removemissing-2.02.02.txt \
+       test/data/vgreduce-removemissing-2.02.66-fail.txt \
+       test/data/vgreduce-removemissing-2.02.66-ok.txt \
+       test/data/vgs-missing-pvs-2.02.02.txt \
+       test/data/vgs-missing-pvs-2.02.66.txt \
+       test/import-export_unittest-helper \
+       test/gnt-cli.test \
+       test/ganeti-cli.test \
+       htest/shelltests/htools-balancing.test \
+       htest/shelltests/htools-basic.test \
+       htest/shelltests/htools-dynutil.test \
+       htest/shelltests/htools-excl.test \
+       htest/shelltests/htools-hail.test \
+       htest/shelltests/htools-hspace.test \
+       htest/shelltests/htools-invalid.test \
+       htest/shelltests/htools-multi-group.test \
+       htest/shelltests/htools-no-backend.test \
+       htest/shelltests/htools-rapi.test \
+       htest/shelltests/htools-single-group.test \
+       htest/shelltests/htools-text-backend.test \
+       htest/data/hail-alloc-drbd.json \
+       htest/data/hail-change-group.json \
+       htest/data/hail-invalid-reloc.json \
+       htest/data/hail-node-evac.json \
+       htest/data/hail-reloc-drbd.json \
+       htest/data/hbal-split-insts.data \
+       htest/data/common-suffix.data \
+       htest/data/invalid-node.data \
+       htest/data/missing-resources.data \
+       htest/data/rapi/groups.json \
+       htest/data/rapi/info.json \
+       htest/data/rapi/instances.json \
+       htest/data/rapi/nodes.json
 
 python_tests = \
+       doc/examples/rapi_testutils.py \
        test/ganeti.asyncnotifier_unittest.py \
        test/ganeti.backend_unittest.py \
        test/ganeti.bdev_unittest.py \
@@ -667,19 +887,24 @@ python_tests = \
        test/ganeti.hypervisor.hv_xen_unittest.py \
        test/ganeti.impexpd_unittest.py \
        test/ganeti.jqueue_unittest.py \
+       test/ganeti.jstore_unittest.py \
        test/ganeti.locking_unittest.py \
        test/ganeti.luxi_unittest.py \
+       test/ganeti.masterd.iallocator_unittest.py \
        test/ganeti.masterd.instance_unittest.py \
        test/ganeti.mcpu_unittest.py \
        test/ganeti.netutils_unittest.py \
        test/ganeti.objects_unittest.py \
+       test/ganeti.objectutils_unittest.py \
        test/ganeti.opcodes_unittest.py \
+       test/ganeti.ovf_unittest.py \
        test/ganeti.qlang_unittest.py \
        test/ganeti.query_unittest.py \
        test/ganeti.rapi.baserlib_unittest.py \
        test/ganeti.rapi.client_unittest.py \
        test/ganeti.rapi.resources_unittest.py \
        test/ganeti.rapi.rlib2_unittest.py \
+       test/ganeti.rapi.testutils_unittest.py \
        test/ganeti.rpc_unittest.py \
        test/ganeti.runtime_unittest.py \
        test/ganeti.serializer_unittest.py \
@@ -700,30 +925,45 @@ python_tests = \
        test/ganeti.utils.wrapper_unittest.py \
        test/ganeti.utils.x509_unittest.py \
        test/ganeti.utils_unittest.py \
+       test/ganeti.vcluster_unittest.py \
        test/ganeti.workerpool_unittest.py \
+       test/qa.qa_config_unittest.py \
        test/cfgupgrade_unittest.py \
        test/docs_unittest.py \
+       test/pycurl_reset_unittest.py \
        test/tempfile_fork_unittest.py
+if HAS_FAKEROOT
+python_tests += test/ganeti.utils.io_unittest-runasroot.py
+endif
 
-haskell_tests = htools/test
+haskell_tests = htest/test
 
 dist_TESTS = \
        test/check-cert-expired_unittest.bash \
        test/daemon-util_unittest.bash \
        test/ganeti-cleaner_unittest.bash \
        test/import-export_unittest.bash \
+       test/cli-test.bash \
+       test/bash_completion.bash \
        $(python_tests)
 
 nodist_TESTS =
+check_SCRIPTS =
+
 if WANT_HTOOLSTESTS
 nodist_TESTS += $(haskell_tests)
+dist_TESTS += htest/offline-test.sh
+check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
 endif
 
 TESTS = $(dist_TESTS) $(nodist_TESTS)
 
 # Environment for all tests
 PLAIN_TESTS_ENVIRONMENT = \
-       PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
+       PYTHONPATH=. \
+       TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
+       PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
+       $(RUN_IN_TEMPDIR)
 
 # Environment for tests run by automake
 TESTS_ENVIRONMENT = \
@@ -756,11 +996,17 @@ srclink_files = \
        test/daemon-util_unittest.bash \
        test/ganeti-cleaner_unittest.bash \
        test/import-export_unittest.bash \
+       test/cli-test.bash \
+       test/bash_completion.bash \
+       htest/offline-test.sh \
+       htest/cli-tests-defs.sh \
        $(all_python_code) \
-       $(HS_LIB_SRCS) $(HS_PROG_SRCS)
+       $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
 
 check_python_code = \
        $(BUILD_BASH_COMPLETION) \
+       $(CHECK_IMPORTS) \
+       $(CHECK_HEADER) \
        $(DOCPP) \
        $(all_python_code)
 
@@ -771,9 +1017,15 @@ lint_python_code = \
        $(python_scripts) \
        $(pkglib_python_scripts) \
        $(BUILD_BASH_COMPLETION) \
+       $(CHECK_IMPORTS) \
+       $(CHECK_HEADER) \
        $(DOCPP) \
        $(PYTHON_BOOTSTRAP)
 
+standalone_python_modules = \
+       lib/rapi/client.py \
+       tools/ganeti-listrunner
+
 pep8_python_code = \
        ganeti \
        ganeti/http/server.py \
@@ -781,6 +1033,7 @@ pep8_python_code = \
        $(python_scripts) \
        $(pkglib_python_scripts) \
        $(BUILD_BASH_COMPLETION) \
+       $(CHECK_HEADER) \
        $(DOCPP) \
        $(PYTHON_BOOTSTRAP) \
        qa
@@ -789,6 +1042,8 @@ test/daemon-util_unittest.bash: daemons/daemon-util
 
 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
 
+test/bash_completion.bash: doc/examples/bash_completion-debug
+
 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
@@ -797,19 +1052,22 @@ devel/upload: devel/upload.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod u+x $@
 
-daemons/%: daemons/%.in $(REPLACE_VARS_SED)
+daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
 
-doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
+doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
+doc/examples/bash_completion: BC_ARGS = --compact
+doc/examples/bash_completion-debug: BC_ARGS =
 
-doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
-       lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
-       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
+doc/examples/bash_completion doc/examples/bash_completion-debug: \
+       $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
+       lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
+       $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
+       PYTHONPATH=. $(RUN_IN_TEMPDIR) \
+         $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
 
 doc/%.png: doc/%.dot
        @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
@@ -825,16 +1083,30 @@ man/footer.html: man/footer.rst
          { echo 'pandoc' not found during configure; exit 1; }
        $(PANDOC) -f rst -t html -o $@ $<
 
-man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
-       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
+man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
+       lib/build/shell_example_lexer.py \
+       | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
+       @echo "Checking $< for hardcoded paths..."
+       @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
+         echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
+         exit 1; \
+       fi
+       set -e ; \
+       trap 'echo auto-removing $@; rm $@' EXIT; \
+       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
+       trap - EXIT
 
 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
        @test -n "$(PANDOC)" || \
          { echo 'pandoc' not found during configure; exit 1; }
        set -o pipefail ; \
+       trap 'echo auto-removing $@; rm $@' EXIT; \
        $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
-         sed -e 's/\\@/@/g' > $@
-       if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
+         sed -e 's/\\@/@/g' > $@; \
+       if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
+       $(CHECK_MAN_DASHES) $@; \
+       trap - EXIT
+
 
 man/%.html.in: man/%.gen man/footer.html
        @test -n "$(PANDOC)" || \
@@ -843,21 +1115,12 @@ man/%.html.in: man/%.gen man/footer.html
        $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
          sed -e 's/\\@/@/g' > $@
 
-man/%.1: man/%.1.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
-
-man/%.7: man/%.7.in $(REPLACE_VARS_SED)
+man/%: man/%.in  $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-man/%.8: man/%.8.in $(REPLACE_VARS_SED)
+epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
 
-man/%.html: man/%.html.in $(REPLACE_VARS_SED)
-       sed -f $(REPLACE_VARS_SED) < $< > $@
-
-epydoc.conf: epydoc.conf.in Makefile
-       sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
-
 vcs-version:
        if test -d .git; then \
          git describe > $@; \
@@ -865,26 +1128,43 @@ vcs-version:
          echo "Cannot auto-generate $@ file"; exit 1; \
        fi
 
+.PHONY: clean-vcs-version
+clean-vcs-version:
+       rm -f vcs-version
+
 .PHONY: regen-vcs-version
 regen-vcs-version:
        set -e; \
        cd $(srcdir); \
        if test -d .git; then \
-         rm -f vcs-version; \
-         $(MAKE) vcs-version; \
+         $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
+         $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
        fi
 
-htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
+htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
+       vcs-version $(built_base_sources)
        set -e; \
        VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
        sed -e "s/%ver%/$$VCSVER/" < $< > $@
 
 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
-       lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
+       lib/constants.py lib/_autoconf.py lib/luxi.py \
+       $(CONVERT_CONSTANTS) $(built_base_sources) \
+       | lib/_vcsversion.py
        set -e; \
        { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
 
-lib/_autoconf.py: Makefile | lib/.dir
+htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
+       $(built_base_sources)
+       set -e; \
+       { cat $< ; \
+         echo ; \
+         for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
+           echo "import $$name ()" ; \
+         done ; \
+       } > $@
+
+lib/_autoconf.py: Makefile | stamp-directories
        set -e; \
        { echo '# This file is automatically generated, do not edit!'; \
          echo '#'; \
@@ -897,7 +1177,7 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo ''; \
          echo '"""'; \
          echo ''; \
-         echo '# pylint: disable-msg=C0301,C0324'; \
+         echo '# pylint: disable=C0301,C0324'; \
          echo '# because this is autogenerated, we do not want'; \
          echo '# style warnings' ; \
          echo ''; \
@@ -915,6 +1195,7 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
          echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
          echo "XEN_INITRD = '$(XEN_INITRD)'"; \
+         echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
          echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
          echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
          echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
@@ -928,8 +1209,10 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
          echo "TOOLSDIR = '$(toolsdir)'"; \
          echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
+         echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
          echo "PKGLIBDIR = '$(pkglibdir)'"; \
-         echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
+         echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
+         echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
          echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
          echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
          echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
@@ -942,14 +1225,20 @@ lib/_autoconf.py: Makefile | lib/.dir
          echo "NODED_USER = '$(NODED_USER)'"; \
          echo "NODED_GROUP = '$(NODED_GROUP)'"; \
          echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
+         echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
          if [ "$(HTOOLS)" ]; then \
            echo "HTOOLS = True"; \
          else \
            echo "HTOOLS = False"; \
          fi; \
+         echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
+         echo "PY_CONFD = $(PY_CONFD)"; \
+         echo "HS_CONFD = $(HS_CONFD)"; \
+         echo "XEN_CMD = '$(XEN_CMD)'"; \
+         echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
        } > $@
 
-lib/_vcsversion.py: Makefile vcs-version | lib/.dir
+lib/_vcsversion.py: Makefile vcs-version | stamp-directories
        set -e; \
        VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
        { echo '# This file is automatically generated, do not edit!'; \
@@ -963,14 +1252,17 @@ lib/_vcsversion.py: Makefile vcs-version | lib/.dir
          echo ''; \
          echo '"""'; \
          echo ''; \
-         echo '# pylint: disable-msg=C0301,C0324'; \
+         echo '# pylint: disable=C0301,C0324'; \
          echo '# because this is autogenerated, we do not want'; \
          echo '# style warnings' ; \
          echo ''; \
          echo "VCS_VERSION = '$$VCSVER'"; \
        } > $@
 
-$(REPLACE_VARS_SED): Makefile
+lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
+       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
+
+$(REPLACE_VARS_SED): Makefile stamp-directories
        set -e; \
        { echo 's#@PREFIX@#$(prefix)#g'; \
          echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
@@ -995,6 +1287,9 @@ $(REPLACE_VARS_SED): Makefile
          echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
          echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
          echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
+         echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
+         echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
+         echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
        } > $@
 
 # Using deferred evaluation
@@ -1002,8 +1297,9 @@ daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
 daemons/ganeti-watcher: MODULE = ganeti.watcher
 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
+$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
 
-$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
+$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
        test -n "$(MODULE)" || { echo Missing module; exit 1; }
        set -e; \
        { echo '#!/usr/bin/python'; \
@@ -1012,7 +1308,7 @@ $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
          echo; \
          echo '"""Bootstrap script for L{$(MODULE)}"""'; \
          echo; \
-         echo '# pylint: disable-msg=C0103'; \
+         echo '# pylint: disable=C0103'; \
          echo '# C0103: Invalid name'; \
          echo; \
          echo 'import sys'; \
@@ -1021,18 +1317,34 @@ $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
          echo '# Temporarily alias commands until bash completion'; \
          echo '# generator is changed'; \
          echo 'if hasattr(main, "commands"):'; \
-         echo '  commands = main.commands # pylint: disable-msg=E1101'; \
+         echo '  commands = main.commands # pylint: disable=E1101'; \
          echo 'if hasattr(main, "aliases"):'; \
-         echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
+         echo '  aliases = main.aliases # pylint: disable=E1101'; \
          echo; \
          echo 'if __name__ == "__main__":'; \
          echo '  sys.exit(main.Main())'; \
        } > $@
        chmod u+x $@
 
+$(HS_BUILT_TEST_HELPERS): Makefile
+       @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
+       set -e; \
+       { echo '#!/bin/sh'; \
+         echo '# This file is automatically generated, do not edit!'; \
+         echo "# Edit Makefile.am instead."; \
+         echo; \
+         echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
+       } > $@
+       chmod u+x $@
+
+stamp-directories: Makefile
+       $(MAKE) $(AM_MAKEFLAGS) ganeti
+       @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
+       touch $@
+
 # We need to create symlinks because "make distcheck" will not install Python
 # files when building.
-stamp-srclinks: Makefile | $(all_dirfiles)
+stamp-srclinks: Makefile | stamp-directories
        set -e; \
        for i in $(srclink_files); do \
                if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
@@ -1046,7 +1358,7 @@ ganeti:
        cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
 
 .PHONY: check-dirs
-check-dirs: $(BUILT_SOURCES)
+check-dirs: $(GENERATED_FILES)
        @set -e; \
        find . -type d \( \( -name . \) -o \( \
                -name .git -o \
@@ -1068,10 +1380,13 @@ check-dirs: $(BUILT_SOURCES)
                if test -n "$$error"; then exit 1; else exit 0; fi; \
        }
 
-check-local: check-dirs
+.PHONY: check-local
+check-local: check-dirs $(GENERATED_FILES)
        $(CHECK_PYTHON_CODE) $(check_python_code)
+       PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
        $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
        $(CHECK_NEWS) < $(top_srcdir)/NEWS
+       PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
        expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
        if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
                echo "Incorrect version in README, expected $$expver"; \
@@ -1086,42 +1401,78 @@ check-local: check-dirs
        done
 
 .PHONY: hs-check
-hs-check: htools/test
+hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
        @rm -f test.tix
-       ./htools/test
+       ./htest/test
+       HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
 
 # E111: indentation is not a multiple of four
+# E121: continuation line indentation is not a multiple of four
+#       (since our indent level is not 4)
+# E125: continuation line does not distinguish itself from next logical line
+#       (since our indent level is not 4)
+# E127: continuation line over-indented for visual indent
+#       (since our indent level is not 4)
+# note: do NOT add E128 here; it's a valid style error in most cases!
+# I've seen real errors, but also some cases were we indent wrongly
+# due to line length; try to rework the cases where it is triggered,
+# instead of silencing it
 # E261: at least two spaces before inline comment
 # E501: line too long (80 characters)
-PEP8_IGNORE = E111,E261,E501
+PEP8_IGNORE = E111,E121,E125,E127,E261,E501
 
 # For excluding pep8 expects filenames only, not whole paths
 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
 
+LINT_TARGETS = pylint pylint-qa
+if HAS_PEP8
+LINT_TARGETS += pep8
+endif
+if HAS_HLINT
+LINT_TARGETS += hlint
+endif
+
 .PHONY: lint
-lint: $(BUILT_SOURCES)
+lint: $(LINT_TARGETS)
+
+.PHONY: pylint
+pylint: $(GENERATED_FILES)
        @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
-       if test -z "$(PEP8)"; then \
-               echo '"pep8" not found during configure' >&2; \
-       else \
-               $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
-                       $(pep8_python_code); \
-       fi
        $(PYLINT) $(LINT_OPTS) $(lint_python_code)
+
+.PHONY: pylint-qa
+pylint-qa: $(GENERATED_FILES)
+       @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
        cd $(top_srcdir)/qa && \
          PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
          --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
 
+.PHONY: pep8
+pep8: $(GENERATED_FILES)
+       @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
+       $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
+               --repeat $(pep8_python_code)
+
+# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
 .PHONY: hlint
-hlint: $(HS_BUILT_SRCS)
+hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
+       @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
        if tty -s; then C="-c"; else C=""; fi; \
-       hlint --report=doc/hs-lint.html $$C htools
+       $(HLINT) --report=doc/hs-lint.html --cross $$C \
+         --ignore "Use first" \
+         --ignore "Use comparing" \
+         --ignore "Use on" \
+         --ignore "Reduce duplication" \
+         --ignore "Use &&&" \
+         --ignore "Use void" \
+         --hint htools/lint-hints \
+         $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
 
 # a dist hook rule for updating the vcs-version file; this is
 # hardcoded due to where it needs to build the file...
 dist-hook:
-       $(MAKE) regen-vcs-version && \
-       rm -f $(top_distdir)/vcs-version && \
+       $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
+       rm -f $(top_distdir)/vcs-version
        cp -p $(srcdir)/vcs-version $(top_distdir)
 
 # a distcheck hook rule for catching revision control directories
@@ -1157,6 +1508,19 @@ distcheck-hook:
 distcheck-release dist-release: export BUILD_RELEASE = 1
 distcheck-release: distcheck
 
+distrebuildcheck: dist
+       set -e; \
+       builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
+       trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
+       cd $$builddir; \
+       tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
+       cd $(distdir); \
+       ./configure; \
+       $(MAKE) maintainer-clean; \
+       cp $(abs_srcdir)/vcs-version .; \
+       ./configure; \
+       $(MAKE) $(AM_MAKEFLAGS)
+
 dist-release: dist
        set -e; \
        for i in $(DIST_ARCHIVES); do \
@@ -1170,11 +1534,6 @@ install-exec-local:
          "$(DESTDIR)${localstatedir}/log/ganeti" \
          "$(DESTDIR)${localstatedir}/run/ganeti"
 
-# To avoid conflicts between directory names and other targets, a file inside
-# the directory is used to ensure its existence.
-%.dir:
-       @mkdir_p@ $* && touch $@
-
 .PHONY: apidoc
 if WANT_HTOOLSAPIDOC
 apidoc: py-apidoc hs-apidoc
@@ -1183,7 +1542,7 @@ apidoc: py-apidoc
 endif
 
 .PHONY: py-apidoc
-py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
+py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
        $(RUN_IN_TEMPDIR) epydoc -v \
                --conf $(CURDIR)/epydoc.conf \
                --output $(CURDIR)/$(APIDOC_PY_DIR)
@@ -1196,8 +1555,11 @@ hs-apidoc: $(HS_BUILT_SRCS)
            { echo 'haddock' not found during configure; exit 1; }
        rm -rf $(APIDOC_HS_DIR)/*
        @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
+       @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
+       @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
        $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
        $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
+       $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
        set -e ; \
        cd htools; \
        if [ "$(HTOOLS_NOCURL)" ]; \
@@ -1207,7 +1569,7 @@ hs-apidoc: $(HS_BUILT_SRCS)
        if [ "$(HTOOLS_PARALLEL3)" ]; \
        then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
        fi; \
-       RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
+       RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
        for file in $$RELSRCS; do \
                hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
                $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
@@ -1220,12 +1582,13 @@ hs-apidoc: $(HS_BUILT_SRCS)
                $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
 
 .PHONY: TAGS
-TAGS: $(BUILT_SOURCES)
+TAGS: $(GENERATED_FILES)
        rm -f TAGS
+       $(GHC) -e ":etags" -v0 $(HFLAGS) $(HS_LIBTEST_SRCS)
        find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
          -path './daemons/ganeti-*' -o -path './tools/*' -o \
          -path './qa/*.py' | \
-         etags -l python -
+         etags -l python -a -
 
 .PHONY: coverage
 if WANT_HTOOLS
@@ -1235,7 +1598,7 @@ coverage: py-coverage
 endif
 
 .PHONY: py-coverage
-py-coverage: $(BUILT_SOURCES) $(python_tests)
+py-coverage: $(GENERATED_FILES) $(python_tests)
        set -e; \
        COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
        TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
@@ -1244,11 +1607,14 @@ py-coverage: $(BUILT_SOURCES) $(python_tests)
        $(python_tests)
 
 .PHONY: hs-coverage
-hs-coverage: $(haskell_tests)
-       cd htools && rm -f *.tix *.mix && ./test
+hs-coverage: $(haskell_tests) htest/hpc-htools
+       rm -f *.tix
+       $(MAKE) $(AM_MAKEFLAGS) hs-check
        @mkdir_p@ $(COVERAGE_HS_DIR)
-       hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
-       hpc report htools/test $(HPCEXCL)
+       hpc combine --union $(HPCEXCL) \
+         test.tix hpc-htools.tix > coverage-htools.tix
+       hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
+       hpc report coverage-htools.tix
        $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
 
 # Special "kind-of-QA" target for htools, needs special setup (all
@@ -1269,6 +1635,21 @@ live-test: all
 
 commit-check: distcheck lint apidoc
 
+.PHONY: gitignore-check
+gitignore-check:
+       @if [ -n "`git status --short`" ]; then \
+         echo "Git status is not clean!" 1>&2 ; \
+         git status --short; \
+         exit 1; \
+       fi
+
+# we don't need the ancient implicit rules:
+%: %,v
+%: RCS/%,v
+%: RCS/%
+%: s.%
+%: SCCS/s.%
+
 -include ./Makefile.local
 
 # vim: set noet :